Index: trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/3.4.0/ALGLIB-3.4.0/dataanalysis.cs
===================================================================
--- trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/3.1.0/ALGLIB-3.1.0/dataanalysis.cs	(revision 6866)
+++ trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/3.4.0/ALGLIB-3.4.0/dataanalysis.cs	(revision 7294)
@@ -1134,7 +2158,12 @@
 
     /*************************************************************************
-
+    This structure is a MCPD (Markov Chains for Population Data) solver.
+
+    You should use ALGLIB functions in order to work with this object.
+
+      -- ALGLIB --
+         Copyright 23.05.2010 by Bochkanov Sergey
     *************************************************************************/
-    public class multilayerperceptron
+    public class mcpdstate
     {
         //
@@ -1142,7 +2171,7 @@
         //
 
-        public multilayerperceptron()
-        {
-            _innerobj = new mlpbase.multilayerperceptron();
+        public mcpdstate()
+        {
+            _innerobj = new mcpd.mcpdstate();
         }
 
@@ -1151,7 +2180,7 @@
         // They are intended for internal use only
         //
-        private mlpbase.multilayerperceptron _innerobj;
-        public mlpbase.multilayerperceptron innerobj { get { return _innerobj; } }
-        public multilayerperceptron(mlpbase.multilayerperceptron obj)
+        private mcpd.mcpdstate _innerobj;
+        public mcpd.mcpdstate innerobj { get { return _innerobj; } }
+        public mcpdstate(mcpd.mcpdstate obj)
         {
             _innerobj = obj;
@@ -1159,598 +2188,33 @@
     }
 
+
     /*************************************************************************
-    Creates  neural  network  with  NIn  inputs,  NOut outputs, without hidden
-    layers, with linear output layer. Network weights are  filled  with  small
-    random values.
+    This structure is a MCPD training report:
+        InnerIterationsCount    -   number of inner iterations of the
+                                    underlying optimization algorithm
+        OuterIterationsCount    -   number of outer iterations of the
+                                    underlying optimization algorithm
+        NFEV                    -   number of merit function evaluations
+        TerminationType         -   termination type
+                                    (same as for MinBLEIC optimizer, positive
+                                    values denote success, negative ones -
+                                    failure)
 
       -- ALGLIB --
-         Copyright 04.11.2007 by Bochkanov Sergey
+         Copyright 23.05.2010 by Bochkanov Sergey
     *************************************************************************/
-    public static void mlpcreate0(int nin, int nout, out multilayerperceptron network)
-    {
-        network = new multilayerperceptron();
-        mlpbase.mlpcreate0(nin, nout, network.innerobj);
-        return;
-    }
-
-    /*************************************************************************
-    Same  as  MLPCreate0,  but  with  one  hidden  layer  (NHid  neurons) with
-    non-linear activation function. Output layer is linear.
-
-      -- ALGLIB --
-         Copyright 04.11.2007 by Bochkanov Sergey
-    *************************************************************************/
-    public static void mlpcreate1(int nin, int nhid, int nout, out multilayerperceptron network)
-    {
-        network = new multilayerperceptron();
-        mlpbase.mlpcreate1(nin, nhid, nout, network.innerobj);
-        return;
-    }
-
-    /*************************************************************************
-    Same as MLPCreate0, but with two hidden layers (NHid1 and  NHid2  neurons)
-    with non-linear activation function. Output layer is linear.
-     $ALL
-
-      -- ALGLIB --
-         Copyright 04.11.2007 by Bochkanov Sergey
-    *************************************************************************/
-    public static void mlpcreate2(int nin, int nhid1, int nhid2, int nout, out multilayerperceptron network)
-    {
-        network = new multilayerperceptron();
-        mlpbase.mlpcreate2(nin, nhid1, nhid2, nout, network.innerobj);
-        return;
-    }
-
-    /*************************************************************************
-    Creates  neural  network  with  NIn  inputs,  NOut outputs, without hidden
-    layers with non-linear output layer. Network weights are filled with small
-    random values.
-
-    Activation function of the output layer takes values:
-
-        (B, +INF), if D>=0
-
-    or
-
-        (-INF, B), if D<0.
-
-
-      -- ALGLIB --
-         Copyright 30.03.2008 by Bochkanov Sergey
-    *************************************************************************/
-    public static void mlpcreateb0(int nin, int nout, double b, double d, out multilayerperceptron network)
-    {
-        network = new multilayerperceptron();
-        mlpbase.mlpcreateb0(nin, nout, b, d, network.innerobj);
-        return;
-    }
-
-    /*************************************************************************
-    Same as MLPCreateB0 but with non-linear hidden layer.
-
-      -- ALGLIB --
-         Copyright 30.03.2008 by Bochkanov Sergey
-    *************************************************************************/
-    public static void mlpcreateb1(int nin, int nhid, int nout, double b, double d, out multilayerperceptron network)
-    {
-        network = new multilayerperceptron();
-        mlpbase.mlpcreateb1(nin, nhid, nout, b, d, network.innerobj);
-        return;
-    }
-
-    /*************************************************************************
-    Same as MLPCreateB0 but with two non-linear hidden layers.
-
-      -- ALGLIB --
-         Copyright 30.03.2008 by Bochkanov Sergey
-    *************************************************************************/
-    public static void mlpcreateb2(int nin, int nhid1, int nhid2, int nout, double b, double d, out multilayerperceptron network)
-    {
-        network = new multilayerperceptron();
-        mlpbase.mlpcreateb2(nin, nhid1, nhid2, nout, b, d, network.innerobj);
-        return;
-    }
-
-    /*************************************************************************
-    Creates  neural  network  with  NIn  inputs,  NOut outputs, without hidden
-    layers with non-linear output layer. Network weights are filled with small
-    random values. Activation function of the output layer takes values [A,B].
-
-      -- ALGLIB --
-         Copyright 30.03.2008 by Bochkanov Sergey
-    *************************************************************************/
-    public static void mlpcreater0(int nin, int nout, double a, double b, out multilayerperceptron network)
-    {
-        network = new multilayerperceptron();
-        mlpbase.mlpcreater0(nin, nout, a, b, network.innerobj);
-        return;
-    }
-
-    /*************************************************************************
-    Same as MLPCreateR0, but with non-linear hidden layer.
-
-      -- ALGLIB --
-         Copyright 30.03.2008 by Bochkanov Sergey
-    *************************************************************************/
-    public static void mlpcreater1(int nin, int nhid, int nout, double a, double b, out multilayerperceptron network)
-    {
-        network = new multilayerperceptron();
-        mlpbase.mlpcreater1(nin, nhid, nout, a, b, network.innerobj);
-        return;
-    }
-
-    /*************************************************************************
-    Same as MLPCreateR0, but with two non-linear hidden layers.
-
-      -- ALGLIB --
-         Copyright 30.03.2008 by Bochkanov Sergey
-    *************************************************************************/
-    public static void mlpcreater2(int nin, int nhid1, int nhid2, int nout, double a, double b, out multilayerperceptron network)
-    {
-        network = new multilayerperceptron();
-        mlpbase.mlpcreater2(nin, nhid1, nhid2, nout, a, b, network.innerobj);
-        return;
-    }
-
-    /*************************************************************************
-    Creates classifier network with NIn  inputs  and  NOut  possible  classes.
-    Network contains no hidden layers and linear output  layer  with  SOFTMAX-
-    normalization  (so  outputs  sums  up  to  1.0  and  converge to posterior
-    probabilities).
-
-      -- ALGLIB --
-         Copyright 04.11.2007 by Bochkanov Sergey
-    *************************************************************************/
-    public static void mlpcreatec0(int nin, int nout, out multilayerperceptron network)
-    {
-        network = new multilayerperceptron();
-        mlpbase.mlpcreatec0(nin, nout, network.innerobj);
-        return;
-    }
-
-    /*************************************************************************
-    Same as MLPCreateC0, but with one non-linear hidden layer.
-
-      -- ALGLIB --
-         Copyright 04.11.2007 by Bochkanov Sergey
-    *************************************************************************/
-    public static void mlpcreatec1(int nin, int nhid, int nout, out multilayerperceptron network)
-    {
-        network = new multilayerperceptron();
-        mlpbase.mlpcreatec1(nin, nhid, nout, network.innerobj);
-        return;
-    }
-
-    /*************************************************************************
-    Same as MLPCreateC0, but with two non-linear hidden layers.
-
-      -- ALGLIB --
-         Copyright 04.11.2007 by Bochkanov Sergey
-    *************************************************************************/
-    public static void mlpcreatec2(int nin, int nhid1, int nhid2, int nout, out multilayerperceptron network)
-    {
-        network = new multilayerperceptron();
-        mlpbase.mlpcreatec2(nin, nhid1, nhid2, nout, network.innerobj);
-        return;
-    }
-
-    /*************************************************************************
-    Randomization of neural network weights
-
-      -- ALGLIB --
-         Copyright 06.11.2007 by Bochkanov Sergey
-    *************************************************************************/
-    public static void mlprandomize(multilayerperceptron network)
-    {
-
-        mlpbase.mlprandomize(network.innerobj);
-        return;
-    }
-
-    /*************************************************************************
-    Randomization of neural network weights and standartisator
-
-      -- ALGLIB --
-         Copyright 10.03.2008 by Bochkanov Sergey
-    *************************************************************************/
-    public static void mlprandomizefull(multilayerperceptron network)
-    {
-
-        mlpbase.mlprandomizefull(network.innerobj);
-        return;
-    }
-
-    /*************************************************************************
-    Returns information about initialized network: number of inputs, outputs,
-    weights.
-
-      -- ALGLIB --
-         Copyright 04.11.2007 by Bochkanov Sergey
-    *************************************************************************/
-    public static void mlpproperties(multilayerperceptron network, out int nin, out int nout, out int wcount)
-    {
-        nin = 0;
-        nout = 0;
-        wcount = 0;
-        mlpbase.mlpproperties(network.innerobj, ref nin, ref nout, ref wcount);
-        return;
-    }
-
-    /*************************************************************************
-    Tells whether network is SOFTMAX-normalized (i.e. classifier) or not.
-
-      -- ALGLIB --
-         Copyright 04.11.2007 by Bochkanov Sergey
-    *************************************************************************/
-    public static bool mlpissoftmax(multilayerperceptron network)
-    {
-
-        bool result = mlpbase.mlpissoftmax(network.innerobj);
-        return result;
-    }
-
-    /*************************************************************************
-    Procesing
-
-    INPUT PARAMETERS:
-        Network -   neural network
-        X       -   input vector,  array[0..NIn-1].
-
-    OUTPUT PARAMETERS:
-        Y       -   result. Regression estimate when solving regression  task,
-                    vector of posterior probabilities for classification task.
-
-    See also MLPProcessI
-
-      -- ALGLIB --
-         Copyright 04.11.2007 by Bochkanov Sergey
-    *************************************************************************/
-    public static void mlpprocess(multilayerperceptron network, double[] x, ref double[] y)
-    {
-
-        mlpbase.mlpprocess(network.innerobj, x, ref y);
-        return;
-    }
-
-    /*************************************************************************
-    'interactive'  variant  of  MLPProcess  for  languages  like  Python which
-    support constructs like "Y = MLPProcess(NN,X)" and interactive mode of the
-    interpreter
-
-    This function allocates new array on each call,  so  it  is  significantly
-    slower than its 'non-interactive' counterpart, but it is  more  convenient
-    when you call it from command line.
-
-      -- ALGLIB --
-         Copyright 21.09.2010 by Bochkanov Sergey
-    *************************************************************************/
-    public static void mlpprocessi(multilayerperceptron network, double[] x, out double[] y)
-    {
-        y = new double[0];
-        mlpbase.mlpprocessi(network.innerobj, x, ref y);
-        return;
-    }
-
-    /*************************************************************************
-    Error function for neural network, internal subroutine.
-
-      -- ALGLIB --
-         Copyright 04.11.2007 by Bochkanov Sergey
-    *************************************************************************/
-    public static double mlperror(multilayerperceptron network, double[,] xy, int ssize)
-    {
-
-        double result = mlpbase.mlperror(network.innerobj, xy, ssize);
-        return result;
-    }
-
-    /*************************************************************************
-    Natural error function for neural network, internal subroutine.
-
-      -- ALGLIB --
-         Copyright 04.11.2007 by Bochkanov Sergey
-    *************************************************************************/
-    public static double mlperrorn(multilayerperceptron network, double[,] xy, int ssize)
-    {
-
-        double result = mlpbase.mlperrorn(network.innerobj, xy, ssize);
-        return result;
-    }
-
-    /*************************************************************************
-    Classification error
-
-      -- ALGLIB --
-         Copyright 04.11.2007 by Bochkanov Sergey
-    *************************************************************************/
-    public static int mlpclserror(multilayerperceptron network, double[,] xy, int ssize)
-    {
-
-        int result = mlpbase.mlpclserror(network.innerobj, xy, ssize);
-        return result;
-    }
-
-    /*************************************************************************
-    Relative classification error on the test set
-
-    INPUT PARAMETERS:
-        Network -   network
-        XY      -   test set
-        NPoints -   test set size
-
-    RESULT:
-        percent of incorrectly classified cases. Works both for
-        classifier networks and general purpose networks used as
-        classifiers.
-
-      -- ALGLIB --
-         Copyright 25.12.2008 by Bochkanov Sergey
-    *************************************************************************/
-    public static double mlprelclserror(multilayerperceptron network, double[,] xy, int npoints)
-    {
-
-        double result = mlpbase.mlprelclserror(network.innerobj, xy, npoints);
-        return result;
-    }
-
-    /*************************************************************************
-    Average cross-entropy (in bits per element) on the test set
-
-    INPUT PARAMETERS:
-        Network -   neural network
-        XY      -   test set
-        NPoints -   test set size
-
-    RESULT:
-        CrossEntropy/(NPoints*LN(2)).
-        Zero if network solves regression task.
-
-      -- ALGLIB --
-         Copyright 08.01.2009 by Bochkanov Sergey
-    *************************************************************************/
-    public static double mlpavgce(multilayerperceptron network, double[,] xy, int npoints)
-    {
-
-        double result = mlpbase.mlpavgce(network.innerobj, xy, npoints);
-        return result;
-    }
-
-    /*************************************************************************
-    RMS error on the test set
-
-    INPUT PARAMETERS:
-        Network -   neural network
-        XY      -   test set
-        NPoints -   test set size
-
-    RESULT:
-        root mean square error.
-        Its meaning for regression task is obvious. As for
-        classification task, RMS error means error when estimating posterior
-        probabilities.
-
-      -- ALGLIB --
-         Copyright 04.11.2007 by Bochkanov Sergey
-    *************************************************************************/
-    public static double mlprmserror(multilayerperceptron network, double[,] xy, int npoints)
-    {
-
-        double result = mlpbase.mlprmserror(network.innerobj, xy, npoints);
-        return result;
-    }
-
-    /*************************************************************************
-    Average error on the test set
-
-    INPUT PARAMETERS:
-        Network -   neural network
-        XY      -   test set
-        NPoints -   test set size
-
-    RESULT:
-        Its meaning for regression task is obvious. As for
-        classification task, it means average error when estimating posterior
-        probabilities.
-
-      -- ALGLIB --
-         Copyright 11.03.2008 by Bochkanov Sergey
-    *************************************************************************/
-    public static double mlpavgerror(multilayerperceptron network, double[,] xy, int npoints)
-    {
-
-        double result = mlpbase.mlpavgerror(network.innerobj, xy, npoints);
-        return result;
-    }
-
-    /*************************************************************************
-    Average relative error on the test set
-
-    INPUT PARAMETERS:
-        Network -   neural network
-        XY      -   test set
-        NPoints -   test set size
-
-    RESULT:
-        Its meaning for regression task is obvious. As for
-        classification task, it means average relative error when estimating
-        posterior probability of belonging to the correct class.
-
-      -- ALGLIB --
-         Copyright 11.03.2008 by Bochkanov Sergey
-    *************************************************************************/
-    public static double mlpavgrelerror(multilayerperceptron network, double[,] xy, int npoints)
-    {
-
-        double result = mlpbase.mlpavgrelerror(network.innerobj, xy, npoints);
-        return result;
-    }
-
-    /*************************************************************************
-    Gradient calculation
-
-    INPUT PARAMETERS:
-        Network -   network initialized with one of the network creation funcs
-        X       -   input vector, length of array must be at least NIn
-        DesiredY-   desired outputs, length of array must be at least NOut
-        Grad    -   possibly preallocated array. If size of array is smaller
-                    than WCount, it will be reallocated. It is recommended to
-                    reuse previously allocated array to reduce allocation
-                    overhead.
-
-    OUTPUT PARAMETERS:
-        E       -   error function, SUM(sqr(y[i]-desiredy[i])/2,i)
-        Grad    -   gradient of E with respect to weights of network, array[WCount]
-
-      -- ALGLIB --
-         Copyright 04.11.2007 by Bochkanov Sergey
-    *************************************************************************/
-    public static void mlpgrad(multilayerperceptron network, double[] x, double[] desiredy, out double e, ref double[] grad)
-    {
-        e = 0;
-        mlpbase.mlpgrad(network.innerobj, x, desiredy, ref e, ref grad);
-        return;
-    }
-
-    /*************************************************************************
-    Gradient calculation (natural error function is used)
-
-    INPUT PARAMETERS:
-        Network -   network initialized with one of the network creation funcs
-        X       -   input vector, length of array must be at least NIn
-        DesiredY-   desired outputs, length of array must be at least NOut
-        Grad    -   possibly preallocated array. If size of array is smaller
-                    than WCount, it will be reallocated. It is recommended to
-                    reuse previously allocated array to reduce allocation
-                    overhead.
-
-    OUTPUT PARAMETERS:
-        E       -   error function, sum-of-squares for regression networks,
-                    cross-entropy for classification networks.
-        Grad    -   gradient of E with respect to weights of network, array[WCount]
-
-      -- ALGLIB --
-         Copyright 04.11.2007 by Bochkanov Sergey
-    *************************************************************************/
-    public static void mlpgradn(multilayerperceptron network, double[] x, double[] desiredy, out double e, ref double[] grad)
-    {
-        e = 0;
-        mlpbase.mlpgradn(network.innerobj, x, desiredy, ref e, ref grad);
-        return;
-    }
-
-    /*************************************************************************
-    Batch gradient calculation for a set of inputs/outputs
-
-    INPUT PARAMETERS:
-        Network -   network initialized with one of the network creation funcs
-        XY      -   set of inputs/outputs; one sample = one row;
-                    first NIn columns contain inputs,
-                    next NOut columns - desired outputs.
-        SSize   -   number of elements in XY
-        Grad    -   possibly preallocated array. If size of array is smaller
-                    than WCount, it will be reallocated. It is recommended to
-                    reuse previously allocated array to reduce allocation
-                    overhead.
-
-    OUTPUT PARAMETERS:
-        E       -   error function, SUM(sqr(y[i]-desiredy[i])/2,i)
-        Grad    -   gradient of E with respect to weights of network, array[WCount]
-
-      -- ALGLIB --
-         Copyright 04.11.2007 by Bochkanov Sergey
-    *************************************************************************/
-    public static void mlpgradbatch(multilayerperceptron network, double[,] xy, int ssize, out double e, ref double[] grad)
-    {
-        e = 0;
-        mlpbase.mlpgradbatch(network.innerobj, xy, ssize, ref e, ref grad);
-        return;
-    }
-
-    /*************************************************************************
-    Batch gradient calculation for a set of inputs/outputs
-    (natural error function is used)
-
-    INPUT PARAMETERS:
-        Network -   network initialized with one of the network creation funcs
-        XY      -   set of inputs/outputs; one sample = one row;
-                    first NIn columns contain inputs,
-                    next NOut columns - desired outputs.
-        SSize   -   number of elements in XY
-        Grad    -   possibly preallocated array. If size of array is smaller
-                    than WCount, it will be reallocated. It is recommended to
-                    reuse previously allocated array to reduce allocation
-                    overhead.
-
-    OUTPUT PARAMETERS:
-        E       -   error function, sum-of-squares for regression networks,
-                    cross-entropy for classification networks.
-        Grad    -   gradient of E with respect to weights of network, array[WCount]
-
-      -- ALGLIB --
-         Copyright 04.11.2007 by Bochkanov Sergey
-    *************************************************************************/
-    public static void mlpgradnbatch(multilayerperceptron network, double[,] xy, int ssize, out double e, ref double[] grad)
-    {
-        e = 0;
-        mlpbase.mlpgradnbatch(network.innerobj, xy, ssize, ref e, ref grad);
-        return;
-    }
-
-    /*************************************************************************
-    Batch Hessian calculation (natural error function) using R-algorithm.
-    Internal subroutine.
-
-      -- ALGLIB --
-         Copyright 26.01.2008 by Bochkanov Sergey.
-
-         Hessian calculation based on R-algorithm described in
-         "Fast Exact Multiplication by the Hessian",
-         B. A. Pearlmutter,
-         Neural Computation, 1994.
-    *************************************************************************/
-    public static void mlphessiannbatch(multilayerperceptron network, double[,] xy, int ssize, out double e, ref double[] grad, ref double[,] h)
-    {
-        e = 0;
-        mlpbase.mlphessiannbatch(network.innerobj, xy, ssize, ref e, ref grad, ref h);
-        return;
-    }
-
-    /*************************************************************************
-    Batch Hessian calculation using R-algorithm.
-    Internal subroutine.
-
-      -- ALGLIB --
-         Copyright 26.01.2008 by Bochkanov Sergey.
-
-         Hessian calculation based on R-algorithm described in
-         "Fast Exact Multiplication by the Hessian",
-         B. A. Pearlmutter,
-         Neural Computation, 1994.
-    *************************************************************************/
-    public static void mlphessianbatch(multilayerperceptron network, double[,] xy, int ssize, out double e, ref double[] grad, ref double[,] h)
-    {
-        e = 0;
-        mlpbase.mlphessianbatch(network.innerobj, xy, ssize, ref e, ref grad, ref h);
-        return;
-    }
-
-}
-public partial class alglib
-{
-
-
-    /*************************************************************************
-    Neural networks ensemble
-    *************************************************************************/
-    public class mlpensemble
+    public class mcpdreport
     {
         //
         // Public declarations
         //
-
-        public mlpensemble()
-        {
-            _innerobj = new mlpe.mlpensemble();
+        public int inneriterationscount { get { return _innerobj.inneriterationscount; } set { _innerobj.inneriterationscount = value; } }
+        public int outeriterationscount { get { return _innerobj.outeriterationscount; } set { _innerobj.outeriterationscount = value; } }
+        public int nfev { get { return _innerobj.nfev; } set { _innerobj.nfev = value; } }
+        public int terminationtype { get { return _innerobj.terminationtype; } set { _innerobj.terminationtype = value; } }
+
+        public mcpdreport()
+        {
+            _innerobj = new mcpd.mcpdreport();
         }
 
@@ -1759,7 +2223,7 @@
         // They are intended for internal use only
         //
-        private mlpe.mlpensemble _innerobj;
-        public mlpe.mlpensemble innerobj { get { return _innerobj; } }
-        public mlpensemble(mlpe.mlpensemble obj)
+        private mcpd.mcpdreport _innerobj;
+        public mcpd.mcpdreport innerobj { get { return _innerobj; } }
+        public mcpdreport(mcpd.mcpdreport obj)
         {
             _innerobj = obj;
